#ifndef __TKSMFMOD_H__
#define __TKSMFMOD_H__

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~                                   ~
//~ TKSFMusicXM                       ~
//~                                   ~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
class TKSFMusicXM : public YAC_Object {
public:
	void *fmod; // anonymous pointer to FMUSIC_MODULE keeps includes local
	sBool fmod_initialized;
	sBool fmod_playing;
	sF32  volume;

public:
	YAC_H(TKSFMusicXM);
	TKSFMusicXM(void);
	~TKSFMusicXM();

	void beginBlock(sF32 *, sU32);

#define YAC_CLASS TKSFMusicXM
#define YAC_NUM_COMMANDS 14

#define YAC_CMD_0_NAME "operator"
#define YAC_CMD_0_RTTI 13
#define YAC_CMD_0_RET 4
#define YAC_CMD_0_SYM yacOperator
	
#define YAC_CMD_1_NAME "loadLocal"
#define YAC_CMD_1_RTTI 3
#define YAC_CMD_1_RET 1
#define YAC_CMD_1_SYM tksinter_loadLocal
	void tksinter_loadLocal(YAC_Object *_s, YAC_Value *_r);

#define YAC_CMD_2_NAME "load"
#define YAC_CMD_2_RTTI 3
#define YAC_CMD_2_RET 1
#define YAC_CMD_2_SYM tksinter_load
	void tksinter_load(YAC_Object *_s, YAC_Value *_r);

#define YAC_CMD_3_NAME "play"
#define YAC_CMD_3_RTTI 0
#define YAC_CMD_3_SYM tksinter_play
	void tksinter_play(void);

#define YAC_CMD_4_NAME "stop"
#define YAC_CMD_4_RTTI 0
#define YAC_CMD_4_SYM tksinter_stop
	void tksinter_stop(void);

#define YAC_CMD_5_NAME "getOrder"
#define YAC_CMD_5_RTTI 0
#define YAC_CMD_5_RET 1
#define YAC_CMD_5_SYM tksinter_getOrder
	void tksinter_getOrder(YAC_Value *_r);

#define YAC_CMD_6_NAME "getRow"
#define YAC_CMD_6_RTTI 0
#define YAC_CMD_6_RET 1
#define YAC_CMD_6_SYM tksinter_getRow
	void tksinter_getRow(YAC_Value *_r);

#define YAC_CMD_7_NAME "getTime"
#define YAC_CMD_7_RTTI 0
#define YAC_CMD_7_RET 1
#define YAC_CMD_7_SYM tksinter_getTime
	void tksinter_getTime(YAC_Value *_r);

#define YAC_CMD_8_NAME "free"
#define YAC_CMD_8_RTTI 0
#define YAC_CMD_8_SYM tksinter_free
	void tksinter_free(void);

#define YAC_CMD_9_NAME "pause"
#define YAC_CMD_9_RTTI 1
#define YAC_CMD_9_SYM tksinter_pause
	void tksinter_pause(sS32);

#define YAC_CMD_10_NAME "init"
#define YAC_CMD_10_RTTI 5
#define YAC_CMD_10_SYM tksinter_init
	void tksinter_init(sS32 _mixrate, sS32 _numsamplesperblock);

#define YAC_CMD_11_NAME "render"
#define YAC_CMD_11_RTTI 3
#define YAC_CMD_11_SYM tksinter_render
	void tksinter_render(YAC_Object *_floatarray);

#define YAC_CMD_12_NAME "setVolume"
#define YAC_CMD_12_RTTI 2
#define YAC_CMD_12_SYM tksinter_setVolume
	void tksinter_setVolume(sF32);

#define YAC_CMD_13_NAME "getVolume"
#define YAC_CMD_13_RTTI 0
#define YAC_CMD_13_RET 2
#define YAC_CMD_13_SYM tksinter_getVolume
	void tksinter_getVolume(YAC_Value *_r);

#include "yac_createcommands.h"

};

#endif
